<?php
/**
 * Plugin Name: JPG to WebP Converter
 * plugin URI: https://wpcollege.com
 * Description: Automatically convert uploaded JPG images to WebP format.
 * Version: 1.0
 * Author: wpcollege
 * Author URI:https://wpcollege.com
 */

// Register the 'wp_handle_upload' filter to convert the image format when uploaded to media library
add_filter('wp_handle_upload', 'convert_to_webp_on_upload', 10, 2);

function convert_to_webp_on_upload($upload, $context) {
    // Check if the uploaded file is an image
    if (strpos($upload['type'], 'image/') === 0) {
        // Get the original file path
        $original_file = $upload['file'];

        // Check if the uploaded file is a JPG image
        if (preg_match('/\.jpe?g$/i', $original_file)) {
            // Create a new filename with the .webp extension
            $webp_file = preg_replace('/\.jpe?g$/i', '.webp', $original_file);

            // Convert the image from JPG to WebP using GD library
            if (imagewebp(imagecreatefromjpeg($original_file), $webp_file)) {
                // Update the 'url' and 'file' keys to include the new WebP file
                $upload['url'] = preg_replace('/\.jpe?g$/i', '.webp', $upload['url']);
                $upload['file'] = $webp_file;
            }
        }
    }

    return $upload;
}
